#!/usr/bin/perl -w
# CGI script for collecting votes
# saves them off in raw x_www_url_encoded (with a few ENV attached)

# CHANGE THIS to a location the user running the web server can write to
$bbdir = "/tmp";

use Fcntl ':flock';

# stdout is goes back to the web-form user as acknowledgement
# must include this http header.
print "Content-type: text/html\r\n\r\n<html><head><title>Voted</title></head><body>";
@in = <STDIN>;
chomp @in;
#"<html><head><title>Voted</title></head><body><pre>Submitting:\r\n";

@b = ();
foreach $i ( @in ) {
	push @b, (split '&', $i);
}
%issues = ();
$curi = "";
$curiv = [];

#print "<pre>";
foreach $c ( @b ) {
	($name,$val) = split '=', $c;
	if ( $name eq "issue" ) {
#		print "issue: $val\r\n";
		if ( $curi ) {
			$issues{$curi} = $curiv;
		}
		$curi = $val;
		$curiv = $issues{$curi};
		if ( ! defined $curiv ) {
			$curiv = [];
		}
	} else {
#		print "\t$c\r\n";
		push @{$curiv}, $c;
	}
}
if ( $curi ) {
	$issues{$curi} = $curiv;
}
#print "</pre>";

# save a few things that might be uset to prevent box stuffers
@l = ();
#$list = "";
foreach $i ( keys %ENV ) {
	if ( $i =~ /(HTTP_REFERER|HTTP_USER_AGENT|REMOTE_ADDR|REMOTE_PORT)/ ) { 
		my $str = $i . "=" . $ENV{$i};
		push @l, $str;
#		$a = $list . "&" . $str;
#		$list = $a;
	}
}

foreach $i ( keys %issues ) {
	$dest = "$bbdir/$i";
	if ( ! -w $dest ) {
		print "<em>bad issue \"$i\", no such ballot box</em>";
	} else {
		$curiv = $issues{$i};
		$o = join '&', @{$curiv}, @l;
		open FOUT, ">>$dest";
		flock FOUT,LOCK_EX;
		print FOUT "$o\n";
		flock FOUT,LOCK_UN;
		close FOUT;
		$o = join '<br>', @{$curiv};
		print "<p>issue <em>$i</em> voted:<br>$o</p>";
	}
}
print "</body></html>\r\n\r\n";
